<?php
/**
*
* I'm request you retain the copyright notice below including the link to site author.
* @package phpBB3
* @version $Id: ajax_thanks.php, v 1.0.6 2010/08/18 01:10:26 Porutchik Exp $
* @copyright (c) 2010 Sergey aka Porutchik, http://forum.aeroion.ru
* @license http://www.opensource.org/licenses/rpl1.5.txt Reciprocal Public License 1.5
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_json.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
// specify styles and/or localisation
$user->setup();

include($phpbb_root_path . 'includes/functions_thanks.' . $phpEx);

// Grab only parameters needed here
$post_id	= request_var('p', 0);
$mode		= utf8_normalize_nfc(request_var('mode', '', true));

// Global parameters
$error 		= false;
$forum_id	= $topic_id = $poster_id = 0;
$post_list 	= $user_cache = $postrow = $row = array();

$response_result = array('error' => $error,
					'thanks_info' => '',
					'thanks_button' => '',
					'thanks_list' => '',
					'thanks_info_user' => '',
					);

// Check permissions and param
switch (true)
{
	case $user->data['is_bot']:
		exit(0);

	case !$user->data['is_registered']:
		set_response_error($user->lang['INCORRECT_THANKS']);
	break;

	case empty($post_id):
		// Do we have a topic or post id?
		set_response_error($user->lang['NO_TOPIC']);
	break;

	case empty($mode):
		set_response_error($user->lang['NO_MODE']);
	break;

	default:
}

if (!$error)
{
	//Get forum and topic info
	/*
	*	@copyright (c) 2005 phpBB Group
	*/

	// This rather complex gaggle of code handles querying for topics but
	// also allows for direct linking to a post (and the calculation of which
	// page the post is on and the correct display of viewtopic)
	$sql_array = array(
		'SELECT' => 't.*, f.*, p.post_id, p.post_approved',

		'FROM'	=> array(
			FORUMS_TABLE => 'f',
			POSTS_TABLE => 'p',
			TOPICS_TABLE => 't',
		),
	);

	// Firebird handles two columns of the same name a little differently, this
	// addresses that by forcing the forum_id to come from the forums table.
	if ($db->sql_layer === 'firebird')
	{
		$sql_array['SELECT'] = 'f.forum_id AS forum_id, ' . $sql_array['SELECT'];
	}

	$sql_array['WHERE'] = "p.post_id = $post_id AND t.topic_id = p.topic_id AND (f.forum_id = t.forum_id";

	// If it is a global announcement make sure to set the forum id to a postable forum
	$sql_array['WHERE'] .= ' OR (t.topic_type = ' . POST_GLOBAL . '
		AND f.forum_type = ' . FORUM_POST . ')';
	
	
	$sql_array['WHERE'] .= ')';

	// Join to forum table on topic forum_id unless topic forum_id is zero
	// whereupon we join on the forum_id passed as a parameter ... this
	// is done so navigation, forum name, etc. remain consistent with where
	// user clicked to view a global topic
	$sql = $db->sql_build_query('SELECT', $sql_array);
	$result = $db->sql_query($sql);
	$topic_data = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	$forum_id = (int) $topic_data['forum_id'];
	$topic_id = (int) $topic_data['topic_id'];
	$post_id = 	(int) $topic_data['post_id'];

	// Check permissions
	switch (true)
	{
		// are we where we are supposed to be?
		case !$topic_data || (!$topic_data['post_approved'] && !$auth->acl_get('m_approve', $topic_data['forum_id'])):
			set_response_error($user->lang['NO_TOPIC']);
		break;
	
		case !$auth->acl_get('f_read', $forum_id):
			// Do we have a topic or post id?
			set_response_error($user->lang['SORRY_AUTH_READ']);
		break;
	
		case !$auth->acl_get('f_thanks', $forum_id):
			set_response_error($user->lang['INCORRECT_THANKS']);
		break;
	
		default:
	}
}

if (!$error)
{
	$post_list = array(0 => $post_id);

	$sql = $db->sql_build_query('SELECT', array(
		'SELECT'	=> 'u.*, p.*',

		'FROM'		=> array(
			USERS_TABLE		=> 'u',
			POSTS_TABLE		=> 'p',
		),

		'WHERE'		=> $db->sql_in_set('p.post_id', $post_list) . '
			AND u.user_id = p.poster_id'
	));

	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);

	$poster_id = (int) $row['poster_id'];
	$user_cache[$poster_id]['allow_thanks_pm'] = $row['user_allow_thanks_pm'];
	//
	$postrow = array(
		'POST_ID'			=> $post_id,
		'POSTER_ID'			=> $poster_id,
		'POST_AUTHOR_FULL'	=> get_username_string('full', $poster_id, $row['username'], $row['user_colour'], $row['post_username']),
		'POST_AUTHOR_COLOUR'=> get_username_string('colour', $poster_id, $row['username'], $row['user_colour'], $row['post_username']),
		'POST_AUTHOR'		=> get_username_string('username', $poster_id, $row['username'], $row['user_colour'], $row['post_username']),
	);

	array_all_thanks($post_list);

	switch ($mode)
	{
		case 'thanks':
			ajax_insert_thanks($post_id, $user->data['user_id'], $poster_id);
		break;

		case 'rthanks':
			ajax_delete_thanks($post_id, $user->data['user_id'], $poster_id);
		break;

		default:
			set_response_error($user->lang['NO_MODE']);
	}
}

if (!$error)
{
	array_all_thanks($post_list);
	output_thanks($user->data['user_id']);

	$template->set_filenames(array(
		'ajax_thanks' => 'ajax_thanks_viewtopic.html')
	);

	// Determine board url - we may need it later
	$board_url = generate_board_url() . '/';
	$web_path = (defined('PHPBB_USE_BOARD_URL_PATH') && PHPBB_USE_BOARD_URL_PATH) ? $board_url : $phpbb_root_path;

	// Dump vars into template
	$template->assign_vars(array(
		'T_THEME_PATH'			=> "{$web_path}styles/" . $user->theme['theme_path'] . '/theme',
		'T_TEMPLATE_PATH'		=> "{$web_path}styles/" . $user->theme['template_path'] . '/template',
		'ROOT_PATH'				=> $phpbb_root_path,
		'S_CONTENT_FLOW_BEGIN'	=> ($user->lang['DIRECTION'] == 'ltr') ? 'left' : 'right',
		'S_CONTENT_FLOW_END'	=> ($user->lang['DIRECTION'] == 'ltr') ? 'right' : 'left',
	));
	$template->assign_block_vars('postrow', $postrow);

	$template->assign_var('S_SHOW_THANKS', 'button');
	$response_result['thanks_button'] = trim(str_replace(array("\r", "\n", "\t"), '', $template->assign_display('ajax_thanks', '',  true)));

	if ($config['thanks_counters_view'] && (get_user_count($poster_id, true) > 0 || get_user_count($poster_id, false) > 0))
	{
		$template->assign_var('S_SHOW_THANKS', 'info');
		$response_result['thanks_info_user'] = trim(str_replace(array("\r", "\n", "\t"), '', $template->assign_display('ajax_thanks', '',  true)));
	}
	if ($config['thanks_postlist_view'] && get_thanks_number($post_id) > 0)
	{
		$template->assign_var('S_SHOW_THANKS', 'list');
		$response_result['thanks_list'] = trim(str_replace(array("\r", "\n", "\t"), '', $template->assign_display('ajax_thanks', '',  true)));
	}

	$response_result['post_id'] = $post_id;

}

// Convert the $response_result array to JSON hash
// and send it to browser
send_php2json_to_browser($response_result);

function set_response_error($message = '')
{
	global $response_result, $error;

	$error = true;
	$response_result['thanks_info'] = ((!empty($response_result['thanks_info'])) ? $response_result['thanks_info'] . "\n" : '') . $message;
	$response_result['error'] = $error;
}

// add a user to the thanks list
function ajax_insert_thanks($post_id, $user_id, $to_id = 0)
{
	global $db, $user, $phpbb_root_path, $phpEx, $forum_id, $config;
	global $response_result;

	$sql_array = array(
		'SELECT'	=> 'p.post_id, p.poster_id, p.topic_id, p.forum_id',
		'FROM'		=> array (POSTS_TABLE => 'p'),
		'WHERE'		=> 'p.post_id ='. (int) $post_id );
	$sql = $db->sql_build_query('SELECT', $sql_array);
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);	
	$db->sql_freeresult($result);

	if ($user->data['user_type'] != USER_IGNORE && !empty($to_id))
	{
		if ($row['poster_id'] != $user_id && $row['poster_id'] == $to_id && !already_thanked($post_id, $user_id))
		{
			$sql = 'INSERT INTO ' . THANKS_TABLE . ' ' . $db->sql_build_array('INSERT', array(
				'user_id'	=> $user_id,
				'post_id'	=> $post_id,
				'poster_id'	=> $to_id,
				'topic_id'	=> $row['topic_id'],
				'forum_id'	=> $row['forum_id'],
				'thanks_time'	=> time()
			));
			$db->sql_query("UPDATE ".USERS_TABLE." SET points=points+".$config['thanks_point_give']." WHERE user_id='".$to_id."'");			
			$db->sql_query($sql);

			$lang_act = 'GIVE';
			send_thanks_pm($user_id, $to_id, true, $post_id, $lang_act);
			
			if ($config['thanks_info_page'])
			{
				$response_result['thanks_info'] = $user->lang['THANKS_INFO_'.$lang_act];
			}

			return;
		}
	}
	set_response_error($user->lang['INCORRECT_THANKS']);
}

// remove a user's thanks
function ajax_delete_thanks($post_id, $user_id, $to_id = 0)
{
	global $db, $user, $phpbb_root_path, $phpEx, $forum_id, $config;
	global $response_result;

	if ($user->data['user_type'] != USER_IGNORE && !empty($to_id))
	{
		$sql = 'DELETE FROM ' . THANKS_TABLE . '
			WHERE post_id ='. (int) $post_id . ' AND user_id = ' . $user->data['user_id'];
		$db->sql_query("UPDATE ".USERS_TABLE." SET points=points-".$config['thanks_point_remove']." WHERE user_id='".$to_id."'");			
		$db->sql_query($sql);	
		$result = $db->sql_affectedrows($sql);	
		if ($result != 0)
		{
			$lang_act = 'REMOVE';
			send_thanks_pm($user_id, $to_id, true, $post_id, $lang_act);

			if ($config['thanks_info_page'])
			{
				$response_result['thanks_info'] = $user->lang['THANKS_INFO_'.$lang_act];
			}

			return;
		}
	}
	set_response_error($user->lang['INCORRECT_THANKS']);
}

?>