<?php
/**
*
* @package phpBB3
* @version $Id$
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
* Minimum Requirement: PHP 4.3.3
*/

/**
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

$show_links_for_all = 0;//show links , emails, ftps for all users includes users and Anonymous
$show_images_for_all = 0;//show images for all users includes users and Anonymous
$show_images_in_lightbox = 0;//show images in light box when user click on image

function closetags($html) {
	#put all opened tags into an array
	preg_match_all('#<([a-z]+)(?: .*)?(?<![/|/ ])>#iU', $html, $result);
	$openedtags = $result[1];
	#put all closed tags into an array
	preg_match_all('#</([a-z]+)>#iU', $html, $result);
	$closedtags = $result[1];
	for($i=0;$i < sizeof($openedtags);$i++){
		if($openedtags[$i] == "br" OR $openedtags[$i] == "BR" OR $openedtags[$i] == "hr" OR $openedtags[$i] == "HR"){
			unset($openedtags[$i]);
		}
	}
	array_filter($openedtags);	
	$len_opened = count($openedtags);
	# all tags are closed
	if (count($closedtags) == $len_opened) {
		return $html;
	}
	$openedtags = array_reverse($openedtags);
	# close tags
	for ($i=0; $i < $len_opened; $i++) {
		if (!in_array($openedtags[$i], $closedtags)){
			$html .= '</'.$openedtags[$i].'>';
		} else {
			unset($closedtags[array_search($openedtags[$i], $closedtags)]);
		}
	}
	return $html;
}

function BBCodeToHTML($text){
global $user, $show_links_for_all, $show_images_for_all, $show_images_in_lightbox;
	$patterns[] = "#  #si";
	$replacements[] = '&nbsp;&nbsp;';

	$patterns[] = "#\t#si";
	$replacements[] = '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';

	//Support Table here
	$patterns[] = "#\[table\]#si";
	$replacements[] = '<table style="border-collapse: collapse;border-spacing: 0px;border: 1px solid #6CAFF7;background-color: #F4F4F4;width:98%;font-family:Verdana,Arial,Sans-Serif,Tahoma;font-size:12px;color: black;">';
	$patterns[] = "#\[\/table\]#si";
	$replacements[] = '</table>';
	$patterns[] = "#\[td\]#si";
	$replacements[] = '<td style="height:25px; border: 1px solid #6CAFF7">';
	$patterns[] = "#\[\/td\]#si";
	$replacements[] = '</td>';
	$patterns[] = "#\[tr\]#si";
	$replacements[] = '<tr>';
	$patterns[] = "#\[\/tr\]#si";
	$replacements[] = '</tr>';

	$patterns[] = "#\[URL=(.*?):(.*?)\](.*?)\[\/URL:(.*?)\]#si";
	
	// Generate logged in/logged out status
	if ($user->data['user_id'] != ANONYMOUS Or $show_links_for_all == 1)
	{
		$replacements[] = '<a href="$1" target="_blank">$3</a>';
	}
	else
	{
	$replacer = '<table width="40%" cellspacing="1" cellpadding="3" border="0"><tr><td bgcolor="#EEEEEE" style="border: 1px solid #AAAAAA;">';
	$replacer .= $user->lang['LOGIN_NOTIFY_FORUM'].'<br />';
	$replacer .= '<a href =../modules.php?name=Your_Account&op=new_user>'.$user->lang['REGISTER'].'</a>';
	$replacer .= '  / ';
	$replacer .= '<a href =../modules.php?name=Your_Account>'.$user->lang['LOGIN'].'</a>';
	$replacer .= '</td></tr></table>';
	$replacements[] = $replacer;
	}

	$patterns[] = "#\[URL=(.*?)\](.*?)\[\/URL\]#si";
	
	// Generate logged in/logged out status
	if ($user->data['user_id'] != ANONYMOUS OR $show_links_for_all == 1)
	{
		$replacements[] = '<a href="$1" target="_blank">$2</a>';
	}
	else
	{
	$replacer = '<table width="40%" cellspacing="1" cellpadding="3" border="0"><tr><td bgcolor="#EEEEEE" style="border: 1px solid #AAAAAA;">';
	$replacer .= $user->lang['LOGIN_FOR_VIEW_LINKS'].'<br />';
	$replacer .= '<a href =../modules.php?name=Your_Account&op=new_user>'.$user->lang['REGISTER'].'</a>';
	$replacer .= '  / ';
	$replacer .= '<a href =../modules.php?name=Your_Account>'.$user->lang['LOGIN'].'</a>';
	$replacer .= '</td></tr></table>';
	$replacements[] = $replacer;
	}	
	
	
	$patterns[] = "#\[email=(.*?):(.*?)\](.*?)\[\/email:(.*?)\]#si";
	
	// Generate logged in/logged out status
	if ($user->data['user_id'] != ANONYMOUS Or $show_links_for_all == 1)
	{
		$replacements[] = '<a href="mailto:$1" target="_blank">$3</a>';
	}
	else
	{
	$replacer1 = '<table width="40%" cellspacing="1" cellpadding="3" border="0"><tr><td bgcolor="#EEEEEE" style="border: 1px solid #AAAAAA;">';
	$replacer1 .= $user->lang['LOGIN_FOR_VIEW_EMAILS'].'<br />';
	$replacer1 .= '<a href =../modules.php?name=Your_Account&op=new_user>'.$user->lang['REGISTER'].'</a>';
	$replacer1 .= '  / ';
	$replacer1 .= '<a href =../modules.php?name=Your_Account>'.$user->lang['LOGIN'].'</a>';
	$replacer1 .= '</td></tr></table>';
	$replacements[] = $replacer1;
	}	
	

	$patterns[] = "#\[img:(.*?)\](.*?)\[\/img:(.*?)\]#si";
	// Generate logged in/logged out status
	if ($user->data['user_id'] != ANONYMOUS Or $show_images_for_all == 1)
	{
		if($show_images_in_lightbox != 1){
			$replacements[] = '<img src="$2" alt="" onLoad="SMR_resize(this);" />';
		}else{
			$replacements[] = '<a href="$2" onMouseOver="SMR_setLink(this);" target="_blank" rel="lightbox$1"><img src="$2" alt="" onLoad="SMR_resize(this);" /></a>';
		}
	}
	else
	{
	$replacer2 = '<table width="40%" cellspacing="1" cellpadding="3" border="0"><tr><td bgcolor="#EEEEEE" style="border: 1px solid #AAAAAA;">';
	$replacer2 .= $user->lang['LOGIN_FOR_VIEW_IMAGES'].'<br />';
	$replacer2 .= '<a href =../modules.php?name=Your_Account&op=new_user>'.$user->lang['REGISTER'].'</a>';
	$replacer2 .= '  / ';
	$replacer2 .= '<a href =../modules.php?name=Your_Account>'.$user->lang['LOGIN'].'</a>';
	$replacer2 .= '</td></tr></table>';
	$replacements[] = $replacer2;
	}

	$patterns[] = "#\[FTP\](.*?)\[\/FTP\]#si";
	
	// Generate logged in/logged out status
	if ($user->data['user_id'] != ANONYMOUS Or $show_links_for_all == 1)
	{
		$replacements[] = '<div class="codetitle"><b>'.$user->lang['CODE'].' FTP:</b></div><div class="ftpcontent">$1</div>';
	}
	else
	{
	$replacer2 = '<table width="40%" cellspacing="1" cellpadding="3" border="0"><tr><td bgcolor="#EEEEEE" style="border: 1px solid #AAAAAA;">';
	$replacer2 .= $user->lang['LOGIN_FOR_VIEW_FTPS'].'<br />';
	$replacer2 .= '<a href =../modules.php?name=Your_Account&op=new_user>'.$user->lang['REGISTER'].'</a>';
	$replacer2 .= '  / ';
	$replacer2 .= '<a href =../modules.php?name=Your_Account>'.$user->lang['LOGIN'].'</a>';
	$replacer2 .= '</td></tr></table>';
	$replacements[] = $replacer2;
	}	

	$patterns[] = "#\[PHP\](.*?)\[\/PHP\]#si";
	$replacements[] = '<div class="codetitle"><b>'.$user->lang['CODE'].' PHP:</b></div><div class="phpcontent">$1</div>';

	$patterns[] = "#\[HTML\](.*?)\[\/HTML\]#si";
	$replacements[] = '<div class="codetitle"><b>'.$user->lang['CODE'].' HTML:</b></div><div class="htmlcontent" style="font-size: 11px;">$1</div>';

	$patterns[] = "#\[FTP\](.*?)\[\/FTP\]#si";
	$replacements[] = '<div class="codetitle"><b>'.$user->lang['CODE'].' FTP:</b></div><div class="ftpcontent">$1</div>';

	$patterns[] = "#\[marq=(.*?)\](.*?)\[\/marq\]#si";
	$replacements[] = '<marquee direction="$1" scrolldelay="20" behavior="scroll" align="center" scrollamount="2" onmouseover="this.stop()" onmouseout="this.start()">$2</marquee>';

	$patterns[] = "#\[TT\](.*?)\[\/TT\]#si";
	$replacements[] = '<div class="codetitle"><b>'.$user->lang['TTCODE'].':</b></div><div class="codecontent"><tt>$1</tt></div>';

	$patterns[] = "#\[FLV\](.*?)\[\/FLV\]#si";
	$replacements[] = '<br><embed src="../includes/jarisplayer.swf" flashvars="file=$1&thumb=lasecta.jpg&logo=logo.png&alphalogo=80" allowFullScreen="true" width="500" height="400" name="fullscreen" align="middle" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" /></embed>';

	$patterns[] = "#\[STREAM\](.*?)\[\/STREAM\]#si";
	$replacements[] = '<object id="wmp" width=300 height=70 classid="CLSID:22d6f312-b0f6-11d0-94ab-0080c74c7e95"
codebase="http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=6,0,0,0"
standby="Loading Microsoft Windows Media Player components..." type="application/x-oleobject">
<param name="FileName" value="$1">
<param name="ShowControls" value="1">
<param name="ShowDisplay" value="0">
<param name="ShowStatusBar" value="1">
<param name="AutoSize" value="1">
<param name="autoplay" value="0">
<embed type="application/x-mplayer2"
pluginspage="http://www.microsoft.com/windows95/downloads/contents/wurecommended/s_wufeatured/mediaplayer/default.asp"
src="$1" name=MediaPlayer2 showcontrols=1 showdisplay=0 showstatusbar=1 autosize=1 autoplay=0 visible=1 animationatstart=0 transparentatstart=1 loop=0 height=70 width=300>
</embed>
</object>

';

	$patterns[] = "#\[(indent|blockquote)\]#si";
	$replacements[] = "<blockquote>";

	$patterns[] = "#\[\/(indent|blockquote)\]#si";
	$replacements[] = "</blockquote>";

	$patterns[] = "#\[(\/|)u:(.*?)\]#si";
	$replacements[] = "<$1u>";
	
	$patterns[] = "#\[(\/|)u(.*?)\]#si";
	$replacements[] = "<$1u>";

	$patterns[] = "#\[(\/|)b:(.*?)\]#si";
	$replacements[] = "<$1strong>";
	
	$patterns[] = "#\[(\/|)b(.*?)\]#si";
	$replacements[] = "<$1strong>";

	$patterns[] = "#\[(\/|)i:(.*?)\]#si";
	$replacements[] = "<$1em>";

	$patterns[] = "#\[(\/|)i(.*?)\]#si";
	$replacements[] = "<$1em>";
	
	$patterns[] = "#\[(sub|sup|strike)(.*?)\]#si";
	$replacements[] = '<$1>';

	$patterns[] = "#\[\/(sub|sup|strike)(.*?)\]#si";
	$replacements[] = '</$1>';

	$patterns[] = "#\[size=85(.*?)\]#si";
	$replacements[] = '<span style="font-size: 8pt">';
	$patterns[] = "#\[size=100(.*?)\]#si";
	$replacements[] = '<span style="font-size: 10pt">';
	$patterns[] = "#\[size=120(.*?)\]#si";
	$replacements[] = '<span style="font-size: 12pt">';
	$patterns[] = "#\[size=130(.*?)\]#si";
	$replacements[] = '<span style="font-size: 14pt">';
	$patterns[] = "#\[size=150(.*?)\]#si";
	$replacements[] = '<span style="font-size: 18pt">';
	$patterns[] = "#\[size=170(.*?)\]#si";
	$replacements[] = '<span style="font-size: 24pt">';
	$patterns[] = "#\[size=200(.*?)\]#si";
	$replacements[] = '<span style="font-size: 36pt">';

	$patterns[] = "#\[size=1(.*?)\]#si";
	$replacements[] = '<span style="font-size: 8pt">';
	$patterns[] = "#\[size=2(.*?)\]#si";
	$replacements[] = '<span style="font-size: 10pt">';
	$patterns[] = "#\[size=3(.*?)\]#si";
	$replacements[] = '<span style="font-size: 12pt">';
	$patterns[] = "#\[size=4(.*?)\]#si";
	$replacements[] = '<span style="font-size: 14pt">';
	$patterns[] = "#\[size=5(.*?)\]#si";
	$replacements[] = '<span style="font-size: 18pt">';
	$patterns[] = "#\[size=6(.*?)\]#si";
	$replacements[] = '<span style="font-size: 24pt">';
	$patterns[] = "#\[size=7(.*?)\]#si";
	$replacements[] = '<span style="font-size: 36pt">';

	$patterns[] = "#\[font=(.*?)\]#si";
	$replacements[] = '<span style="font-family:$1;">';

	$patterns[] = "#\[color=(.*?)\]#si";
	$replacements[] = '<span style="color:$1;">';

	$patterns[] = "#\[highlight=(.*?)\]#si";
	$replacements[] = '<span style="background-color:$1;">';

	$patterns[] = "#\[\/(font|highlight|color|size)(.*?)\]#si";
	$replacements[] = '</span>';

	$patterns[] = "#\[hr\]#si";
	$replacements[] = '<hr class=HR_Color>';

	$patterns[] = "#\[(left|center|right|justify)(.*?)\]#si";
	$replacements[] = '<div align="$1">';

	$patterns[] = "#\[\/(left|center|right|justify)(.*?)\]#si";
	$replacements[] = '</div>';

	$text = preg_replace($patterns, $replacements, $text);

	return closetags($text);
}

require($phpbb_root_path . 'includes/startup.' . $phpEx);

if (file_exists($phpbb_root_path . 'config.' . $phpEx))
{
	require($phpbb_root_path . 'config.' . $phpEx);
}

if (!defined('PHPBB_INSTALLED'))
{
	// Redirect the user to the installer
	// We have to generate a full HTTP/1.1 header here since we can't guarantee to have any of the information
	// available as used by the redirect function
	$server_name = (!empty($_SERVER['HTTP_HOST'])) ? strtolower($_SERVER['HTTP_HOST']) : ((!empty($_SERVER['SERVER_NAME'])) ? $_SERVER['SERVER_NAME'] : getenv('SERVER_NAME'));
	$server_port = (!empty($_SERVER['SERVER_PORT'])) ? (int) $_SERVER['SERVER_PORT'] : (int) getenv('SERVER_PORT');
	$secure = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') ? 1 : 0;

	$script_name = (!empty($_SERVER['PHP_SELF'])) ? $_SERVER['PHP_SELF'] : getenv('PHP_SELF');
	if (!$script_name)
	{
		$script_name = (!empty($_SERVER['REQUEST_URI'])) ? $_SERVER['REQUEST_URI'] : getenv('REQUEST_URI');
	}

	// Replace any number of consecutive backslashes and/or slashes with a single slash
	// (could happen on some proxy setups and/or Windows servers)
	$script_path = trim(dirname($script_name)) . '/install/index.' . $phpEx;
	$script_path = preg_replace('#[\\\\/]{2,}#', '/', $script_path);

	$url = (($secure) ? 'https://' : 'http://') . $server_name;

	if ($server_port && (($secure && $server_port <> 443) || (!$secure && $server_port <> 80)))
	{
		// HTTP HOST can carry a port number...
		if (strpos($server_name, ':') === false)
		{
			$url .= ':' . $server_port;
		}
	}

	$url .= $script_path;
	header('Location: ' . $url);
	exit;
}

if (defined('DEBUG_EXTRA'))
{
	$base_memory_usage = 0;
	if (function_exists('memory_get_usage'))
	{
		$base_memory_usage = memory_get_usage();
	}
}

// Load Extensions
// dl() is deprecated and disabled by default as of PHP 5.3.
if (!empty($load_extensions) && function_exists('dl'))
{
	$load_extensions = explode(',', $load_extensions);

	foreach ($load_extensions as $extension)
	{
		@dl(trim($extension));
	}
}

// Include files
require($phpbb_root_path . 'includes/acm/acm_' . $acm_type . '.' . $phpEx);
require($phpbb_root_path . 'includes/cache.' . $phpEx);
require($phpbb_root_path . 'includes/template.' . $phpEx);
require($phpbb_root_path . 'includes/session.' . $phpEx);
require($phpbb_root_path . 'includes/auth.' . $phpEx);

require($phpbb_root_path . 'includes/functions.' . $phpEx);
require($phpbb_root_path . 'includes/functions_content.' . $phpEx);

require($phpbb_root_path . 'includes/constants.' . $phpEx);
require($phpbb_root_path . 'includes/db/' . $dbms . '.' . $phpEx);
require($phpbb_root_path . 'includes/utf/utf_tools.' . $phpEx);

// Set PHP error handler to ours
set_error_handler(defined('PHPBB_MSG_HANDLER') ? PHPBB_MSG_HANDLER : 'msg_handler');

// Instantiate some basic classes
$user		= new user();
$auth		= new auth();
$template	= new template();
$cache		= new cache();
$db			= new $sql_db();

// Connect to DB
$db->sql_connect($dbhost, $dbuser, $dbpasswd, $dbname, $dbport, false, defined('PHPBB_DB_NEW_LINK') ? PHPBB_DB_NEW_LINK : false);

// We do not need this any longer, unset for safety purposes
unset($dbpasswd);

// Grab global variables, re-cache if necessary
$config = $cache->obtain_config();
// www.phpBB-SEO.com SEO TOOLKIT BEGIN
if (empty($phpbb_seo) ) {
	require_once($phpbb_root_path . 'phpbb_seo/phpbb_seo_class.'.$phpEx);
	$phpbb_seo = new phpbb_seo();
	@define('PHPBB_USE_BOARD_URL_PATH', true);
}
// www.phpBB-SEO.com SEO TOOLKIT END
// Add own hook handler
require($phpbb_root_path . 'includes/hooks/index.' . $phpEx);
$phpbb_hook = new phpbb_hook(array('exit_handler', 'phpbb_user_session_handler', 'append_sid', array('template', 'display')));

foreach ($cache->obtain_hooks() as $hook)
{
	@include($phpbb_root_path . 'includes/hooks/' . $hook . '.' . $phpEx);
}



$row = $db->sql_fetchrow($db->sql_query("SELECT `Default_Theme`, `language`, `multilingual` FROM ".$prefix."_config"));
$nukeLanguage = $row['language'];
$nukeMultilingual = $row['multilingual'];

$http_language_code=array();

$http_language_code['afrikaans']	= 'af'; //
$http_language_code['arabic']		= 'ar'; //
$http_language_code['belarusian']	= 'be'; //
$http_language_code['bulgarian']	= 'bg'; //  
$http_language_code['catalan']		= 'ca'; //  
$http_language_code['czech']		= 'cs'; //  
$http_language_code['danish']		= 'da'; //
$http_language_code['german']		= 'de'; // (Standard)
$http_language_code['greek']		= 'el'; //  
$http_language_code['english']		= 'en'; //  
$http_language_code['spanish']		= 'es'; // (Argentina)
$http_language_code['estonian']		= 'et'; //  
$http_language_code['basque']		= 'eu'; //
$http_language_code['farsi']		= 'fa'; //  
$http_language_code['finnish']		= 'fi'; //
$http_language_code['faeroese']		= 'fo'; //
$http_language_code['french']		= 'fr'; // (Standard)  
$http_language_code['french']		= 'fr'; // (Belgium)
$http_language_code['gaelic']		= 'gd'; // (Scotland)
$http_language_code['hebrew']		= 'he'; //
$http_language_code['hindi']		= 'hi'; //  
$http_language_code['croatian']		= 'hr'; //
$http_language_code['hungarian']	= 'hu'; //
$http_language_code['indonesian']	= 'id'; //
$http_language_code['italian']		= 'it'; // (Standard)  
$http_language_code['icelandic']	= 'is'; //  
$http_language_code['korean']		= 'kr';		// korean
$http_language_code['japanese']		= 'ja'; //  
$http_language_code['yiddish']		= 'ji'; //
$http_language_code['latvian']		= 'lv'; //
$http_language_code['lithuanian']	= 'lt'; //  
$http_language_code['macedonian']	= 'mk'; // (FYROM)
$http_language_code['malaysian']	= 'ms'; //  
$http_language_code['maltese']		= 'mt';	//
$http_language_code['dutch']		= 'nl'; // (Standard)  
$http_language_code['norwegian']	= 'no'; // (Nynorsk)
$http_language_code['polish']		= 'pl'; //  
$http_language_code['portuguese']	= 'pt'; // (Portugal)  
$http_language_code['rhaeto-Romanic'] = 'rm'; //
$http_language_code['romanian']		= 'ro'; //  
$http_language_code['russian']		= 'ru';; //  
$http_language_code['sorbian']		= 'sb'; //
$http_language_code['slovak']		= 'sk'; //
$http_language_code['slovenian']	= 'sl'; //  
$http_language_code['albanian']		= 'sq'; //
$http_language_code['serbian']		= 'sr'; // (Latin)  
$http_language_code['sutu']			= 'sx'; //
$http_language_code['sami']			= 'sz'; // (Lappish)  
$http_language_code['swedish']		= 'sv'; //  
$http_language_code['swedish']		= 'sv-fi'; // (Finland)
$http_language_code['thai']			= 'th'; //  
$http_language_code['tswana']		= 'tn'; //  
$http_language_code['tsonga']		= 'ts'; //
$http_language_code['turkish']		= 'tr'; //
$http_language_code['urdu']			= 'ur'; //
$http_language_code['vietnamese']	= 'vi'; //
$http_language_code['ukrainian']	= 'uk'; //  
$http_language_code['venda']		= 've'; //  
$http_language_code['xhosa']		= 'xh'; //  
$http_language_code['chinese']		= 'zh'; // (Chinese Standard)
$http_language_code['zulu']			= 'zu'; //

$nukeUserLanguage = "";


if (isset($_COOKIE['nukelang']))
{
	$nukeUserLanguage = $_COOKIE['nukelang'];

	if ($nukeMultilingual)
	{
		$phpBB3LanguageName = $http_language_code[$nukeUserLanguage];
	}
	else
	{
		$phpBB3LanguageName = $http_language_code[$nukeLanguage];
	};

	unset($http_language_code);
}
else
{
	$phpBB3LanguageName = $http_language_code[$nukeLanguage];
};

?>