<?php
/**
*
* @package phpBB3
* @version $Id: create_pdf.php 2009-06-09 12:42 $
* @copyright (c) 2007 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);

include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/bbcode.' . $phpEx);
include($phpbb_root_path . 'pdf24_api.'.$phpEx);

$user->session_begin();
$user->setup('mods/pdf24');
$auth->acl($user->data);

//get parameters
$topic_id = request_var('t', 0);

//get topic title
$sql = "SELECT topic_title
		FROM ". TOPICS_TABLE ."
		WHERE topic_id = $topic_id";
$result = $db->sql_query($sql);
$topic_data = $db->sql_fetchrow($result);
$db->sql_freeresult($result);

if(!$topic_data) {
	echo $user->lang['TOPIC_INVALID'];
	exit;
}

$sql = "SELECT t1.bbcode_uid, t1.bbcode_bitfield, t1.post_text, t1.post_subject, t1.topic_id, t1.forum_id, t1.post_id, t1.post_time, t2.username
		FROM ". POSTS_TABLE ." as t1, ". USERS_TABLE ." as t2
		WHERE topic_id = $topic_id AND t1.poster_id = t2.user_id
		ORDER BY t1.post_time ASC";
$result = $db->sql_query($sql, $config['posts_per_page']);

$bbcode_bitfield = '';
$total_posts = 0;
$postrow = array();

while ($row = $db->sql_fetchrow($result)) {
	$postrow[] = $row;
	$bbcode_bitfield = $bbcode_bitfield | base64_decode($row['bbcode_bitfield']);
}
$db->sql_freeresult($result);
$total_posts = count($postrow);

// Instantiate BBCode if need be
if ($bbcode_bitfield !== '') {
	$bbcode = new bbcode(base64_encode($bbcode_bitfield));
}
$forum_url = generate_board_url();

//Build pdf filename
$search = array('/','\\',':','?','*','"','|','<','>');
$pdf_filename = $config['sitename'] . ' - ' . $topic_data['topic_title'];
$pdf_filename = str_replace($search, '_', $pdf_filename);

//build the document with pdf24 api
$doc = new PDF24Doc();
$doc->setHeadline($config["sitename"]);
$doc->setHeadlineUrl($forum_url);
$doc->setBaseUrl($forum_url);
$doc->setCharset("utf-8");
$doc->setPdfFileName($pdf_filename);

foreach($postrow as $row) {
	$text = $row["post_text"];
	$title = $row["post_subject"];
	$title_url = $forum_url . "viewtopic.$phpEx?t=".$row["topic_id"]."&f=".$row["forum_id"]."#".$row["post_id"];
	$author = $row["username"];
	$time_stamp = $user->format_date($row["post_time"]);
	
	// Second parse bbcode here
	if ($row['bbcode_bitfield']) {
		$bbcode->bbcode_second_pass($text, $row['bbcode_uid'], $row['bbcode_bitfield']);
	}
	$text = bbcode_nl2br($text);
	$text = smiley_text($text);
	
	$doc->addPart($text, $title, $title_url, $author, $time_stamp);
}

//do the request
$response = $doc->doRequest();
$statusLocation = $response->getStatusLocation();
if($statusLocation) {
	header('Location:' . $statusLocation);
	exit;
} else {
	//should never occur
}

?>