<?php

//
// This MOD is Created by Mehrdad Khoddami 
// http://www.ePark.ir
// khoddami.me@gmail.com
//



function div($a, $b) {
	return (int) ($a / $b);
}

function gregorian_to_jalali($g_y, $g_m, $g_d)
{
	$g_days_in_month = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
	$j_days_in_month = array(31, 31, 31, 31, 31, 31, 30, 30, 30, 30, 30, 29);
	$gy = $g_y - 1600;
	$gm = $g_m - 1;
	$gd = $g_d - 1;
	$g_day_no = 365 * $gy + div($gy + 3,4) - div($gy + 99, 100) + div($gy + 399, 400);

	for ($i=0 ; $i < $gm ; ++$i)
	{
		$g_day_no += $g_days_in_month[$i];
	}

	if ($gm>1 && (($gy % 4 == 0 && $gy % 100 != 0) || ($gy % 400 == 0)))
	{
		$g_day_no++; // leap and after Feb
	}

	$g_day_no += $gd;
	$j_day_no = $g_day_no - 79;
	$j_np = div($j_day_no, 12053); // 12053 = 365*33 + 32/4
	$j_day_no = $j_day_no % 12053;
	$jy = 979 + 33 * $j_np + 4 * div($j_day_no, 1461); // 1461 = 365*4 + 4/4
	$j_day_no %= 1461;

	if ($j_day_no >= 366)
	{
		$jy += div($j_day_no - 1, 365);
		$j_day_no = ($j_day_no - 1) % 365;
	}

	for ($i = 0 ; $i < 11 && $j_day_no >= $j_days_in_month[$i] ; ++$i)
	{
		$j_day_no -= $j_days_in_month[$i];
	}

	$jm = $i + 1;
	$jd = $j_day_no + 1;
	return array($jy, $jm, $jd);
}

function tranasmonth($number, $nukelanguage, $nukedatetype) {
global $j_month_name, $A_month_name, $g_month_name;
	if($nukedatetype == 1){
	$month = array(
		1	=> $j_month_name[1],
		2	=> $j_month_name[2],
		3	=> $j_month_name[3],
		4	=> $j_month_name[4],
		5	=> $j_month_name[5],
		6	=> $j_month_name[6],
		7	=> $j_month_name[7],
		8	=> $j_month_name[8],
		9	=> $j_month_name[9],
		10	=> $j_month_name[10],
		11	=> $j_month_name[11],
		12	=> $j_month_name[12],
	);
	}elseif($nukedatetype == 2){
	$month = array(
		1	=> $A_month_name[0],
		2	=> $A_month_name[1],
		3	=> $A_month_name[2],
		4	=> $A_month_name[3],
		5	=> $A_month_name[4],
		6	=> $A_month_name[5],
		7	=> $A_month_name[6],
		8	=> $A_month_name[7],
		9	=> $A_month_name[8],
		10	=> $A_month_name[9],
		11	=> $A_month_name[10],
		12	=> $A_month_name[11],
	);
	}else{
	$month = array(
		1	=> $g_month_name[1],
		2	=> $g_month_name[2],
		3	=> $g_month_name[3],
		4	=> $g_month_name[4],
		5	=> $g_month_name[5],
		6	=> $g_month_name[6],
		7	=> $g_month_name[7],
		8	=> $g_month_name[8],
		9	=> $g_month_name[9],
		10	=> $g_month_name[10],
		11	=> $g_month_name[11],
		12	=> $g_month_name[12],
	);	
	}
	return strtr($number, $month);
}

function jalali_true_format($format, $date_trans, $zone_offset, $gmepoch, $nukelanguage, $nukedatetype)
{

	$part = explode(" ", @gmdate('Y m d', $gmepoch));
	list( $jy, $jm, $jd ) = gregorian_to_jalali($part[0], $part[1], $part[2]);
	$format = str_replace('Y', $jy, $format);// year as 2 digits
	$format = str_replace('y', $jy, $format);// year as 4 digits
	$format = str_replace('M', tranasmonth($jm, $nukelanguage, $nukedatetype), $format);// month as 3 lettersto letters in Persian
	$format = str_replace('m', tranasmonth($jm, $nukelanguage, $nukedatetype), $format);// month as 2 digits to letters in Persian
	$format = str_replace('F', tranasmonth($jm, $nukelanguage, $nukedatetype), $format);// month ,long form to letters in Persian
	$format = str_replace('n', tranasmonth($jm, $nukelanguage, $nukedatetype), $format);// month as digits without leading zero to letters in Persian 
	$format = str_replace('d', $jd, $format);// day of the month with leading zero to digits without zero : 03 to 3
	$format = str_replace('j', $jd, $format);// day of the month as digits without leading zero
	$format = str_replace('S', ' ام', $format);// for translating English ordinal suffix as 2 character to Persian: "st, nd, rd, th" to " ام"
	if($zone_offset == 12600){
		if($jm >= 1 && $jm <=6)
			$zone_offset = 16200;
	}
	return @strtr(@gmdate($format, $gmepoch + $zone_offset), $date_trans);
}


//**********************Gregorian date to hehri date
   function monthName($k) // $i = 1..12
   {
		global $A_month_name;
       return $A_month_name[$k-1];
   }
   function GregorianToHijri($format, $date_trans, $zone_offset, $gmepoch=null, $nukelanguage, $nukedatetype)
   {
		if ($gmepoch === null) $gmepoch = time();
		$m = date('m', $gmepoch);
		$d = date('d', $gmepoch);
		$y = date('Y', $gmepoch);
		$part = JDToHijri(
           cal_to_jd(CAL_GREGORIAN, $m, $d, $y));
		$Ay = $part[2];
		$Am = (int) $part[0];
		$Ad = $part[1];
		$format = str_replace('Y', substr($Ay, 2, 2), $format);// year as 2 digits
		$format = str_replace('y', $Ay, $format);// year as 4 digits
		$format = str_replace('M', tranasmonth($Am, $nukelanguage, $nukedatetype), $format);// month as 3 lettersto letters in Persian
		$format = str_replace('m', tranasmonth($Am, $nukelanguage, $nukedatetype), $format);// month as 2 digits to letters in Persian
		$format = str_replace('F', tranasmonth($Am, $nukelanguage, $nukedatetype), $format);// month ,long form to letters in Persian
		$format = str_replace('n', tranasmonth($Am, $nukelanguage, $nukedatetype), $format);// month as digits without leading zero to letters in Persian 
		$format = str_replace('d', $Ad, $format);// day of the month with leading zero to digits without zero : 03 to 3
		$format = str_replace('j', $Ad, $format);// day of the month as digits without leading zero
		$format = str_replace('S', ' ام', $format);// for translating English ordinal suffix as 2 character to Persian: "st, nd, rd, th" to " ام"	   
	   
		if($zone_offset == 12600){
			if($jm >= 1 && $jm <=6)
				$zone_offset = 16200;
		}
       return strtr(@gmdate($format, $gmepoch + $zone_offset), $date_trans);
   }
   function HijriToGregorian($m, $d, $y)
   {
       return jd_to_cal(HijriToJD($m, $d, $y));
   }
   # Julian Day Count To Hijri
   function JDToHijri($jd)
   {
       $jd = $jd - 1948440 + 10632;
       $n  = (int)(($jd - 1) / 10631);
       $jd = $jd - 10631 * $n + 354;
       $j  = ((int)((10985 - $jd) / 5316)) *
           ((int)(50 * $jd / 17719)) +
           ((int)($jd / 5670)) *
           ((int)(43 * $jd / 15238));
       $jd = $jd - ((int)((30 - $j) / 15)) *
           ((int)((17719 * $j) / 50)) -
           ((int)($j / 16)) *
           ((int)((15238 * $j) / 43)) + 29;
       $m  = (int)(24 * $jd / 709);
       $d  = $jd - (int)(709 * $m / 24);
       $y  = 30*$n + $j - 30;
       return array($m, $d, $y);
   }
   # Hijri To Julian Day Count
   function HijriToJD($m, $d, $y)
   {
       return 0; 

   }


/*************************************/
/*****************/

function Gregorian($month){
global $g_month_name;
return $g_month_name[$month];
}


?>