<?php
/** 
*
* @package phpBB3
* @version $Id: quickedit.php 430 2010-02-12 11:52:11Z marc1706 $
* @copyright (c) 2006 StarTrekGuide Group, (c) 2009 - 2010 Marc Alexander(marc1706) www.m-a-styles.de
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('posting');
$user->add_lang('viewtopic');

$post_id = request_var('post_id', 0);
$submit = isset($_POST['submit']) ? true : false;
$contents = utf8_normalize_nfc(request_var('contents', '', true));
$attach_list = array();


if ($contents == 'cancel')
{
	$sql = 'SELECT *
			FROM ' . POSTS_TABLE . '
			WHERE post_id = ' . $post_id;	
	$result = $db->sql_query($sql);
	$post_data = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	
	$topic_id = $post_data['topic_id'];
	
	//now check to see if the user is allowed to read the post
	if (!$auth->acl_get('f_read', $post_data['forum_id']) && $post_data['forum_id'] != 0)
	{
		die($user->lang['USER_CANNOT_READ']);
	}
	
	/*	Pull attachment data
	*	@copyright (c) 2005 phpBB Group
	*/
	if ($post_data['post_attachment'] && $config['allow_attachments'])
	{
		$attach_list[] = (int) $post_data['post_id'];

		if ($post_data['post_approved'])
		{
			$has_attachments = true;
		}
	}
	
	if (sizeof($attach_list))
	{
		if ($auth->acl_get('u_download') && $auth->acl_get('f_download', $post_data['forum_id']))
		{
			$sql = 'SELECT *
				FROM ' . ATTACHMENTS_TABLE . '
				WHERE ' . $db->sql_in_set('post_msg_id', $attach_list) . '
					AND in_message = 0
				ORDER BY filetime DESC, post_msg_id ASC';
			$result = $db->sql_query($sql);

			while ($row = $db->sql_fetchrow($result))
			{
				$attachments[$row['post_msg_id']][] = $row;
			}
			$db->sql_freeresult($result);

			// No attachments exist, but post table thinks they do so go ahead and reset post_attach flags
			if (!sizeof($attachments))
			{
				$sql = 'UPDATE ' . POSTS_TABLE . '
					SET post_attachment = 0
					WHERE ' . $db->sql_in_set('post_id', $attach_list);
				$db->sql_query($sql);

			}
		}
		else
		{
			$display_notice = true;
		}
	}
	
	$post_data['bbcode_options'] = (($post_data['enable_bbcode']) ? OPTION_FLAG_BBCODE : 0) + (($post_data['enable_smilies']) ? OPTION_FLAG_SMILIES : 0) + (($post_data['enable_magic_url']) ? OPTION_FLAG_LINKS : 0);
	$text = generate_text_for_display($post_data['post_text'], $post_data['bbcode_uid'], $post_data['bbcode_bitfield'], $post_data['bbcode_options']);
	
	if (!empty($attachments[$post_data['post_id']]))
	{
		parse_attachments($post_data['forum_id'], $text, $attachments[$post_data['post_id']], $update_count);
	}

	$template->assign_vars(array(
		'SEND_TEXT'				=> true,
		'TEXT'      			=> $text,
		'EDIT_IMG' 				=> $user->img('icon_post_edit', 'EDIT_POST'),
		'DELETE_IMG'			=> $user->img('icon_post_delete', 'DELETE_POST'),
	));
}
elseif ($submit)
{
	$sql = 'SELECT p.*, f.*, t.*, u.*
	FROM ' . POSTS_TABLE . ' p, ' . TOPICS_TABLE . ' t, ' . FORUMS_TABLE . ' f, ' . USERS_TABLE . " u
	WHERE p.post_id = $post_id AND p.topic_id = t.topic_id AND p.forum_id = f.forum_id AND p.poster_id = u.user_id";	
	$result = $db->sql_query($sql);
	$post_data = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	
	$topic_id = $post_data['topic_id'];
	
	//first check to see if we are registered and have rights to edit something here
	if ($user->data['is_registered'] && $auth->acl_gets('f_edit', 'm_edit', $post_data['forum_id']))
	{
		$is_authed = true;
	}
	else
	{
		die($user->lang['USER_CANNOT_EDIT']);	
	}
	
	//now check to see if this forum is locked and if we aren't a mod that can edit anything
	if (($post_data['forum_status'] == ITEM_LOCKED || (isset($post_data['topic_status']) && $post_data['topic_status'] == ITEM_LOCKED)) && !$auth->acl_get('m_edit', $post_data['forum_id']))
	{
		die($user->lang(($post_data['forum_status'] == ITEM_LOCKED) ? 'FORUM_LOCKED' : 'TOPIC_LOCKED'));	
	}
	
	//now check to see if we can edit THIS post
	if (!$auth->acl_get('m_edit', $post_data['forum_id']))
	{
		if ($user->data['user_id'] != $post_data['poster_id'])
		{
			die($user->lang['USER_CANNOT_EDIT']);	
		}
	
		if (!($post_data['post_time'] > time() - ($config['edit_time'] * 60) || !$config['edit_time']))
		{
			die($user->lang['CANNOT_EDIT_TIME']);	
		}
	
		if ($post_data['post_edit_locked'])
		{
			die($user->lang['CANNOT_EDIT_POST_LOCKED']);	
		}
	}
	
	//now check if we need to set the edit time and edit count
	if (!$auth->acl_get('m_edit', $post_data['forum_id']))
	{
		$edit_time = time();
		$edit_count = $post_data['post_edit_count'] + 1;
		$edit_user = $user->data['user_id'];
	}
	else 
	{
		$edit_time = (isset($post_data['post_edit_time'])) ? $post_data['post_edit_time'] : 0;
		$edit_user = (isset($post_data['post_edit_user'])) ? $post_data['post_edit_user'] : 0;
		$edit_count = (isset($post_data['post_edit_count'])) ? $post_data['post_edit_count'] : 0; 
	}
	
	// Add moderator edit to the moderator log
	if (($user->data['user_id'] != $post_data['poster_id']) && ($auth->acl_get('m_edit', $post_data['forum_id'])))
	{
		add_log('mod', $post_data['forum_id'], $post_data['topic_id'], 'LOG_POST_EDITED', $post_data['topic_title'], (!empty($post_data['username'])) ? $post_data['username'] : $user->lang['GUEST']);
	}
	
	$post_text = utf8_normalize_nfc(request_var('contents', '', true));	
	$uid = $bitfield = $options = ''; // will be modified by generate_text_for_storage
	$allow_bbcode = ($post_data['enable_bbcode']) ? true : false;
	$allow_urls = ($post_data['enable_magic_url']) ? true : false;
	$allow_smilies = ($post_data['enable_smilies']) ? true : false;
	generate_text_for_storage($post_text, $uid, $bitfield, $options, $allow_bbcode, $allow_urls, $allow_smilies);
	
	
	// let's try something else here in order to get the bbcode_uid and bbcode_bitfield
	$message_parser = new parse_message();
	
	$message_parser->message = $post_text;
	
	if(!isset($uid))
	{
		$uid = $message_parser->bbcode_uid;
	}
	
	if(!isset($bitfield))
	{
		$bitfield = $message_parser->bbcode_bitfield;
	}

	$sql_ary = array(
		'post_text'         => $post_text,
		'bbcode_uid'		=> $uid,
		'bbcode_bitfield'   => $bitfield,
		'post_edit_time'	=> $edit_time,
		'post_edit_count'	=> $edit_count,
		'post_edit_user'	=> $edit_user,

	);

	$sql = 'UPDATE ' . POSTS_TABLE . ' SET ' . $db->sql_build_array('UPDATE', $sql_ary) . " WHERE post_id = $post_id";	
	$db->sql_query($sql);
	
	/*	Pull attachment data
	*	@copyright (c) 2005 phpBB Group
	*/
	if ($post_data['post_attachment'] && $config['allow_attachments'])
	{
		$attach_list[] = (int) $post_data['post_id'];
	}
	
	if (sizeof($attach_list))
	{
		if ($auth->acl_get('u_download') && $auth->acl_get('f_download', $post_data['forum_id']))
		{
			$sql = 'SELECT *
				FROM ' . ATTACHMENTS_TABLE . '
				WHERE ' . $db->sql_in_set('post_msg_id', $attach_list) . '
					AND in_message = 0
				ORDER BY filetime DESC, post_msg_id ASC';
			$result = $db->sql_query($sql);

			while ($row = $db->sql_fetchrow($result))
			{
				$attachments[$row['post_msg_id']][] = $row;
			}
			$db->sql_freeresult($result);

			// No attachments exist, but post table thinks they do so go ahead and reset post_attach flags
			if (!sizeof($attachments))
			{
				$sql = 'UPDATE ' . POSTS_TABLE . '
					SET post_attachment = 0
					WHERE ' . $db->sql_in_set('post_id', $attach_list);
				$db->sql_query($sql);

			}
		}
	}
	
	$text = generate_text_for_display($sql_ary['post_text'], $sql_ary['bbcode_uid'], $sql_ary['bbcode_bitfield'], 7);
	
	if (!empty($attachments[$post_data['post_id']]))
	{
		parse_attachments($post_data['forum_id'], $text, $attachments[$post_data['post_id']], $update_count);
	}
	
	$template->assign_vars(array(
		'SEND_TEXT'				=> true,
		'TEXT'					=> $text,
		'EDIT_IMG' 				=> $user->img('icon_post_edit', 'EDIT_POST'),
		'DELETE_IMG'			=> $user->img('icon_post_delete', 'DELETE_POST'),
	));
}
elseif ($post_id)
{
	$sql = 'SELECT p.*, f.*, t.*
	FROM ' . POSTS_TABLE . ' p, ' . TOPICS_TABLE . ' t, ' . FORUMS_TABLE . " f
	WHERE p.post_id = $post_id AND p.topic_id = t.topic_id";	
	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrow($result);
	$db->sql_freeresult($result);
	
	// HTML, BBCode, Smilies, Images and Flash status
	$bbcode_status	= ($config['allow_bbcode'] && ($auth->acl_get('f_bbcode', $row['forum_id']) || $row['forum_id'] == 0)) ? true : false;
	$smilies_status	= ($bbcode_status && $config['allow_smilies'] && $auth->acl_get('f_smilies', $row['forum_id'])) ? true : false;
	$img_status		= ($bbcode_status && $auth->acl_get('f_img', $row['forum_id'])) ? true : false;
	$url_status		= ($config['allow_post_links']) ? true : false;
	$flash_status	= ($bbcode_status && $auth->acl_get('f_flash', $row['forum_id']) && $config['allow_post_flash']) ? true : false;
	$quote_status	= ($auth->acl_get('f_reply', $row['forum_id'])) ? true : false;
	
	//first check to see if we are registered and have rights to edit something here
	if ($user->data['is_registered'] && $auth->acl_gets('f_edit', 'm_edit', $row['forum_id']))
	{
		$is_authed = true;
	}
	else
	{
		die($user->lang['USER_CANNOT_EDIT']);
	}
	
	//now check to see if this forum is locked and if we aren't a mod that can edit anything
	if ($row['forum_status'] == ITEM_LOCKED || (((isset($row['topic_status']) && $row['topic_status'] == ITEM_LOCKED)) && !$auth->acl_get('m_edit', $row['forum_id'])))
	{
		die($user->lang[(($row['forum_status'] == ITEM_LOCKED) ? 'FORUM_LOCKED' : 'TOPIC_LOCKED')]);
	}
	
	//now check to see if we can edit THIS post
	if (!$auth->acl_get('m_edit', $row['forum_id']))
	{
		if ($user->data['user_id'] != $row['poster_id'])
		{
			die($user->lang['USER_CANNOT_EDIT']);
		}
	
		if (!($row['post_time'] > time() - ($config['edit_time'] * 60) || !$config['edit_time']))
		{
			die($user->lang['CANNOT_EDIT_TIME']);
		}
	
		if ($row['post_edit_locked'])
		{
			die($user->lang['CANNOT_EDIT_POST_LOCKED']);
		}
	}

	$text = utf8_normalize_nfc($row['post_text']);
	$text = generate_text_for_edit($text, $row['bbcode_uid'], '');
	
	// Build custom bbcodes array
	display_custom_bbcodes();
	
	// Give a valid forum_id for Advanced Edit if we have a global announcement
	if(!isset($row['forum_id']) || $row['forum_id'] <= 0)
	{
		$forums_ary = $auth->acl_getf('f_edit');
		$forum_id = array_search(true, $forums_ary);
	}
	
	$template->assign_vars(array(
		'EDIT_FORM'				=> true,
		'POST_ID'				=> $post_id,
		'POST_TEXT'   			=> $text['text'],
		'EDIT_IMG' 				=> $user->img('icon_post_edit', 'EDIT_POST'),
		'DELETE_IMG'			=> $user->img('icon_post_delete', 'DELETE_POST'),
        'S_LINKS_ALLOWED'        => $url_status,
        'S_BBCODE_IMG'            => $img_status,
		'S_BBCODE_URL'			=> $url_status,
		'S_BBCODE_FLASH'		=> $flash_status,
		'S_BBCODE_QUOTE'		=> $quote_status,
		'S_BBCODE_ALLOWED'		=> $bbcode_status,
		'MAX_FONT_SIZE'			=> (int) $config['max_post_font_size'],
		'MAX_POST_CHARS'		=> (isset($config['max_post_chars']) ? $config['max_post_chars'] : 0) ,
		'MAX_POST_CHARS_LANG'	=> $user->lang['TOO_MANY_CHARS_POST'],
		'MIN_POST_CHARS_LANG'	=> $user->lang['TOO_FEW_CHARS_LIMIT'],
		'NO_POST_CHARS_LANG'	=> $user->lang['TOO_FEW_CHARS'],
		'MIN_POST_CHARS'		=> (isset($config['min_post_chars'])) ? $config['min_post_chars'] : 0,
		'U_ADVANCED_EDIT'		=> append_sid("{$phpbb_root_path}posting.$phpEx", "mode=edit" . (($row['forum_id'] > 0) ? ('&amp;f=' . $row['forum_id']) : ('&amp;f=' . $forum_id)) . "&amp;p={$row['post_id']}"),
	));
}
else
{
	die($user->lang['USER_CANNOT_EDIT']);
}

$template->set_filenames(array(
	'body' => 'quickedit.html')
);
page_footer();

?>